﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.filters.*;
	
	/**
	* 放射線ブラー
	*/
	public class RadiationBlur extends MovieClip 
	{	
		/**
		* ノイズ用ビットマップデータオブジェクト
		*/
		private var noise:BitmapData;
		
		/**
		* コンストラクタ
		*/
		public function RadiationBlur()
		{
			noise = new BitmapData(200, 200, true);
			
			// タイムラインの親Spriteに追加
			noiseRect.addChild(new Bitmap(noise));
			
			// グラデーションマスクを設定(タイムライン上でcacheAsBitmapを設定している)
			noiseRect.mask = maskRect;
		}
		
		/**
		* ノイズのアップデート
		*/
		public function updateNoise():void
		{
			// パーリンノイズでランダムノイズ作成
			noise.perlinNoise(10 + Math.random() * 50, 0, 1, Math.random() * 10000, false, false, 0, true);
			
			// ノイズの強弱を透明度で設定
			noiseRect.alpha = Math.random() > .5 ? .1 : 1;
			
			// ノイズの強弱を明度でも設定
			// 明度の適用値
			var b:Number = Math.random() * 3; //適宜適用量は調整
			var blightnessArr:Array =
			[
				b, 0, 0, 0, 0,
				0, b, 0, 0, 0,
				0, 0, b, 0, 0,
				0, 0, 0, .4, 0
			];
			var blightnessFilter:ColorMatrixFilter = new ColorMatrixFilter(blightnessArr);
			this.filters = [blightnessFilter, blightnessFilter];
		}
		
	}
}
